echo off
cls
if exist ftpsync.txt goto init
echo off
cls
echo.
echo You have never run this script, so a settings file has been created.
echo All it contains is the name of your shared save file.
echo Be sure to use the same shared save file as your group!
echo.
echo This settings file is called ftpsync.txt
echo.
echo Right now it contains "overwritable" which is the default, there
echo is no way of knowing what will be in there. Give it a go if you
echo dare...
echo.
echo You can use notepad to change that file and enter a new name. If
echo there is no shared save with that name, you can create one
echo within KSP.
echo.
echo Be sure to ONLY type in the name of the shared save, NO newlines
echo and no spaces. Spaces in shared save games are not allowed right now.
echo Trailing spaces will be ignored.
echo.
echo This script will now let you edit the save name.
echo Hit save when you're done!
echo.
echo Have fun! mkb@libero.it
<nul set /p "savename=overwritable" > ftpsync.txt
rem start /wait notepad ftpsync.txt
rem set /p "savename=overwritable" > ftpsync.txt
echo.
echo.
set /p savename="Enter save name, no spaces: "
<nul set /p "savename=%savename%" > ftpsync.txt
echo.
echo Using save name: %savename%
echo.
:init
set /P savename=<ftpsync.txt
set ksp_missions_old=noneyet
set ksp_scenetrans_old=notyet
cd saves
mkdir %savename%
cd %savename%
mkdir Ships
cd Ships
mkdir VAB
mkdir SPH
cd ..
:returnfromempty
if not exist persistent.sfs goto getempty
echo Be sure to use the %savename% save file! No other file will be synchronized.
rem Use log files to see if KSP exists and runs
if not exist ..\..\KSP.log echo dummyfile > ..\..\KSP.log
if not exist KSP.log echo dummyfile > KSP.log
move ..\..\KSP.log ..\..\KSP.mog 2>nul
if %errorlevel%==0 goto kspset
goto noksp
:kspset
move KSP.log KSP.mog 2>nul
if %errorlevel%==0 goto noksp

:loopme
rem see if ksp is still going
move KSP.log KSP.mog 2>nul
if %errorlevel%==0 goto end
if not exist ksp.log goto abort
rem find the magic phrase in ksp.log and write down how often it occurs, to get an idea of game state
for /f "delims=" %%a in ('find /C "Game State Saved as persistent" ksp.log') do @set ksp_missions_new=%%a
for /f "delims=" %%a in ('find /C "to MAINMENU" ksp.log') do @set ksp_scenetrans_new=%%a
rem echo %ksp_missions_new%
if "%ksp_scenetrans_old%"=="notyet" goto syncread
if not "%ksp_missions_old%"=="%ksp_missions_new%" goto syncwrite
if not "%ksp_scenetrans_old%"=="%ksp_scenetrans_new%" goto syncread
rem echo Probably nothing to do, waiting a little to check again.
goto waithere

:syncwrite
set ksp_missions_old=%ksp_missions_new%
echo Local saveable data has changed, uploading to server.
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
copy /y persistent.sfs %savename%.ksp >nul
echo open f3.to > ftp_put.scr
echo ksp@fthree.org >> ftp_put.scr
echo PfwHxaUO0dNg>> ftp_put.scr
echo put %savename%.ksp >> ftp_put.scr
echo disconnect >> ftp_put.scr
echo bye >> ftp_put.scr
ftp -i -s:"ftp_put.scr" > nul
if not %errorlevel%==0 goto abord
echo Done, resuming wait.
goto waithere

:syncread
set ksp_scenetrans_old=%ksp_scenetrans_new%
rem prevents immediate reupload
set ksp_missions_old=%ksp_missions_new%
echo Local saveable data is retrievable, retrieving from server.
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
echo open emlia.org > ftp_get.scr
echo ksp_shared@spiritplumber.com >> ftp_get.scr
echo c5ZTrG7nHqGr>> ftp_get.scr
echo get %savename%.ksp >> ftp_get.scr
echo disconnect >> ftp_get.scr
echo bye >> ftp_get.scr
ftp -i -s:"ftp_get.scr" > nul
if not %errorlevel%==0 goto abort
for %%F in (*) do if %%~zF equ 0 del "%%F"
copy /y %savename%.ksp persistent.sfs >nul
echo Done, resuming wait.
goto waithere

:waithere
ping -n 10 localhost>nul
goto loopme

:noksp
echo Launching KSP for you.
echo.
del ksp.mog >nul 2>nul
del ..\..\ksp.mog >nul 2>nul
start ..\..\KSP.exe
rem if your pc loads ksp in less than 40 seconds, i hate you anyway :P
ping -n 40 localhost>nul
rem initialize
for /f "delims=" %%a in ('find /C "Game State Saved as persistent" ksp.log') do @set ksp_missions_new=%%a
for /f "delims=" %%a in ('find /C "to MAINMENU" ksp.log') do @set ksp_scenetrans_new=%%a
rem force read (and finish initializing the variables)
goto syncread

:getempty
echo Getting known-good empty save file from server.
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
echo open emlia.org > ftp_get.scr
echo ksp_shared@spiritplumber.com >> ftp_get.scr
echo c5ZTrG7nHqGr>> ftp_get.scr
echo get empty.save >> ftp_get.scr
echo disconnect >> ftp_get.scr
echo bye >> ftp_get.scr
ftp -i -s:"ftp_get.scr" > nul
if not %errorlevel%==0 goto abort
for %%F in (*) do if %%~zF equ 0 del "%%F"
copy /y empty.save persistent.sfs >nul
echo Done, resuming script.
goto returnfromempty


:abort
echo Something derped.
pause

:end
del ftp_get.scr
del ftp_put.scr
del %savename%.ksp
del ..\..\ksp.mog >nul 2>nul
del ..\..\ksp_%savename%_old.log >nul 2>nul
move ksp.mog ..\..\ksp_%savename%_old.log
del ksp.mog >nul 2>nul
