:preinit
set savename=overwritable
rem this deletes all empty files (housekeeping)
for %%F in (*) do if %%~zF equ 0 del "%%F"
if exist ftpsync.txt goto init
echo off
cls
echo.
echo You have never run this script, so a settings file has been created.
echo All it contains is the name of your shared save file.
echo Be sure to use the same shared save file as your group!
echo.
echo This settings file is called ftpsync.txt
echo.
echo Right now it contains "overwritable" which is the default, there
echo is no way of knowing what will be in there. Give it a go if you
echo dare...
echo.
echo You can use notepad to change that file and enter a new name. If
echo there is no shared save with that name, you can create one
echo within KSP.
echo.
echo Be sure to ONLY type in the name of the shared save, NO newlines
echo and no spaces. Spaces in shared save games are not allowed right now.
echo Trailing spaces will be ignored.
echo.
echo This script will now let you edit the save name.
echo Hit save when you're done!
echo.
echo Have fun! mkb@libero.it
<nul set /p "savename=overwritable" > ftpsync.txt
rem start /wait notepad ftpsync.txt
rem set /p "savename=overwritable" > ftpsync.txt
echo.
echo.
set /p savename="Enter save name, no spaces: "
<nul set /p "savename=%savename%" > ftpsync.txt
echo.
echo Using save name: %savename%
echo.


:init
echo off
set /P savename=<ftpsync.txt
rem this is to make sure subassemblymanager works
mkdir pluginData\subassemblyLoader
mkdir pluginData\subassemblyLoader\subassemblies
mkdir pluginData\subassemblyLoader\subassemblies\Landers
mkdir pluginData\subassemblyLoader\subassemblies\Lifters
mkdir pluginData\subassemblyLoader\subassemblies\Probes
mkdir pluginData\subassemblyLoader\subassemblies\Impactors
mkdir pluginData\subassemblyLoader\subassemblies\Other

:start
cls
if not %savename%==overwritable goto nowarn
if "%savename%"=="" goto abort
:warn
echo.
echo You should probably edit the settings file and change the save name to something else!
echo.
echo Close this window now, or press a key to continue with the overwritable save name.
echo.
pause >nul

:nowarn
mkdir saves
cd saves
mkdir %savename%
cd %savename%
mkdir Ships
mkdir Ships\VAB
mkdir Ships\SPH
for %%F in (*) do if %%~zF equ 0 del "%%F"
if exist %savename%.ksp copy /y %savename%.ksp persistent.sfs


:ftp_get
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
echo open f3.to > ftp_get.scr
echo ksp@fthree.org >> ftp_get.scr
echo PfwHxaUO0dNg>> ftp_get.scr
echo get %savename%.ksp >> ftp_get.scr
echo disconnect >> ftp_get.scr
echo bye >> ftp_get.scr

ftp -i -s:"ftp_get.scr"
if not %errorlevel%==0 goto abort
copy /y %savename%.ksp persistent.sfs
if not %errorlevel%==0 goto abort
for %%F in (*) do if %%~zF equ 0 del "%%F"
:returnfromempty
if exist persistent.sfs goto runme
if not exist persistent.sfs goto getempty
goto abort

:runme
cls
echo.
echo KSP is now running. Be sure to use the %savename% save.
echo.
start /wait /low ../../KSP.exe
if not %errorlevel%==0 goto abort


:afterrun
del ksp.log
copy /y persistent.sfs %savename%.ksp
if not %errorlevel%==0 goto abort

:ftp_put
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
echo open f3.to > ftp_put.scr
echo ksp@fthree.org >> ftp_put.scr
echo PfwHxaUO0dNg>> ftp_put.scr
echo put %savename%.ksp >> ftp_put.scr
echo disconnect >> ftp_put.scr
echo bye >> ftp_put.scr

ftp -i -s:"ftp_put.scr"
if not %errorlevel%==0 goto abort

del %savename%.ksp
del ftp_put.scr
del ftp_get.scr
cd ..
cd ..
goto done

:getempty
echo Getting known-good empty save file from server.
rem I know that I'm giving away a password. I made a ftp account for just this and nothing else. Nyah nyah.
echo open emlia.org > ftp_get.scr
echo ksp_shared@spiritplumber.com >> ftp_get.scr
echo c5ZTrG7nHqGr>> ftp_get.scr
echo get empty.save >> ftp_get.scr
echo disconnect >> ftp_get.scr
echo bye >> ftp_get.scr
ftp -i -s:"ftp_get.scr" > nul
if not %errorlevel%==0 goto abort
for %%F in (*) do if %%~zF equ 0 del "%%F"
copy /y empty.save persistent.sfs >nul
echo Done, resuming script.
goto returnfromempty


:abort
echo %errorlevel%
echo.
echo Something went wrong. See above.

pause
:done
pause

